﻿#region

using System.Collections.Generic;
using System.Linq;
using McLovin;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.POI;
using Styx.CommonBot.Routines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

#endregion

namespace Superbad
{
    public partial class Classname : CombatRoutine
    {
        private static readonly HashSet<uint> _shred = new HashSet<uint>
            {
                56846, // Arm Tentacle -- Madness of DW
                56167, // Arm Tentacle -- Madness of DW
                56168, // Wing Tentacle - Madness of DW
                57962, // Deathwing ----- Madness of DW (his head)
                56471, // Mutated Corruption 
            };

        private static readonly string[] SoulSwapDebuffs = new[]
            {
                "Rake",
                "Rip"
            };


        public static HashSet<uint> CanShredBoss
        {
            get { return _shred; }
        }

        private static bool swipe_cat()
        {
            return !(target.distance > 8) && Spell.Cast("Swipe");
        }

        public static bool heart_of_the_wild()
        {
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.CurrentTarget != null && !target.IsBoss(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            return SuperbadSettings.Instance.useHotW && Spell.CastTalentBuff("Heart of the Wild");
        }

        private static bool wrath()
        {
            if (!SuperbadSettings.Instance.WrathSpam)
                return false;
            return !(target.distance > 40) && Spell.Cast("Wrath");
        }

        private static bool cat_form()
        {
            if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                return false;
            if (SuperbadSettings.Instance.Form == 3)
                return false;

            return Spell.Buff("Cat Form", StyxWoW.Me);
        }

        private static bool aquatic_form()
        {
            if (!HasSpellAquaticForm)
                return false;
            if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Aqua)
                return false;
            return Spell.Buff("Aquatic Form", StyxWoW.Me);
        }

        private static bool savage_roar()
        {
            if (StyxWoW.Me.Shapeshift != ShapeshiftForm.Cat)
                return false;
            if (!HasSpellSavageRoar)
                return false;
            if (!TalentManager.Savagery && StyxWoW.Me.RawComboPoints < 1)
                return false;
            if (TalentManager.Savagery)
            {
                return Spell.CastHack(127538);
            }
            return Spell.CastHack(52610);
        }

        private static bool skull_bash_cat()
        {
            if (!SuperbadSettings.Instance.UseInterrupts)
                return false;
            if (StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget.IsPet)
                return false;
            if (target.distance > 13)
                return false;
            if (StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget.IsCasting &&
                StyxWoW.Me.CurrentTarget.CanInterruptCurrentSpellCast &&
                !Spell.DoubleCastEntries.ContainsKey("Interrupt"))
                if (Spell.Cast("Skull Bash", true))
                {
                    Spell.UpdateDoubleCastEntries("Interrupt", 0.5);
                    return true;
                }
            return false;
        }

        private static bool healing_touch()
        {
            if (!StyxWoW.Me.GroupInfo.IsInParty || !SuperbadSettings.Instance.HealOthers)
                return Spell.Heal("Healing Touch");

            var healTarget = GetHealTarget();

            return healTarget != null ? Spell.Heal("Healing Touch", healTarget) : Spell.Heal("Healing Touch");
        }

        private static WoWPlayer GetHealTarget()
        {
            return (from unit in ObjectManager.GetObjectsOfType<WoWPlayer>(true, true)
                    orderby unit.HealthPercent ascending
                    where (unit.IsInMyParty || unit.IsInMyRaid || unit.IsMe)
                    where !unit.IsDead && !unit.IsGhost
                    where unit.IsFriendly
                    where unit.Distance < 40
                    where unit.InLineOfSight
                    where unit.HealthPercent < 90
                    select unit).FirstOrDefault();
        }


        private static bool tigers_fury()
        {
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            if (target.time_to_die <= 3)
                return false;
            return Spell.Buff("Tiger's Fury", true);
        }

        private static bool berserk()
        {
            if (!SuperbadSettings.Instance.UseBerserk)
                return false;
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            if (StyxWoW.Me.IsInInstance &&
                !target.IsBoss(StyxWoW.Me.CurrentTarget) && !target.IsTrainingDummy(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (target.time_to_die <= 25)
                return false;
            return Spell.Buff("Berserk", true);
        }

        private static bool natures_vigil()
        {
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.CurrentTarget != null && !target.IsBoss(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            return Spell.CastTalentBuff(124974);
        }

        private static bool incarnation()
        {
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.CurrentTarget != null && !target.IsBoss(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            if (StyxWoW.Me.Specialization == WoWSpec.DruidGuardian)
            {
                return Spell.CastTalentBuff("Incarnation: Son of Ursoc");
            }
            return Spell.CastTalentBuff(102543);
        }

        private static bool faerie_fire()
        {
            if (!SuperbadSettings.Instance.UseFFF)
                return false;
            if (target.distance > 35)
                return false;
            return TalentManager.FaerieSwarm ? Spell.CastTalent(102355) : Spell.Cast("Faerie Fire", true);
        }

        private static bool faerie_firecatcombat()
        {
            if (!SuperbadSettings.Instance.UseFFF)
                return false;
            if (StyxWoW.Me.CurrentTarget != null)
                if (!StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                    return false;
            return TalentManager.FaerieSwarm ? Spell.CastTalent(102355) : Spell.Cast("Faerie Fire", true);
        }

        private static bool ferocious_bite()
        {
            if (target.distance > MeleeRange)
                return false;
            if (combo_points < 1)
                return false;
            return Spell.Cast("Ferocious Bite");
        }

        private static bool thrash_cat()
        {
            return !(target.distance > 8) && Spell.Cast(106832);
        }

        private static bool thrash_cat_guardian()
        {
            return !(target.distance > MeleeRange) && Spell.Cast(106830);
        }

        private static bool natures_swiftness()
        {
            if (!SuperbadSettings.Instance.UseNaturesSwiftness)
                return false;
            if (!StyxWoW.Me.CachedHasAura(132158))
                return Spell.Heal("Nature's Swiftness", true);
            return false;
        }

        private static bool rip()
        {
            return !(target.distance > MeleeRange) && Spell.Cast("Rip");
        }

        private static bool ravage()
        {
            if (target.distance > MeleeRange)
                return false;
            if ((buff.king_of_the_jungle.up || StyxWoW.Me.CachedHasAura(81022) || (buff.prowl.up &&
                                                                                   StyxWoW.Me.CurrentTarget != null &&
                                                                                   StyxWoW.Me.CurrentTarget.MeIsBehind)))
            {
                return Spell.Cast("Ravage");
            }
            return false;
        }

        private static bool shred()
        {
            if (target.distance > MeleeRange)
                return false;
            if (StyxWoW.Me.Specialization == WoWSpec.DruidGuardian)
            {
                return mangle();
            }
            if (StyxWoW.Me.CurrentTarget != null)
                if (StyxWoW.Me.CurrentTarget.MeIsBehind ||
                    IsShredBoss(StyxWoW.Me.CurrentTarget) ||
                    TalentManager.Shred && (StyxWoW.Me.CachedHasAura(5217) ||
                                            StyxWoW.Me.CachedHasAura(106951)))
                {
                    return Spell.Cast("Shred");
                }
            if (StyxWoW.Me.CurrentTarget != null)
                if (!(StyxWoW.Me.CurrentTarget.MeIsBehind ||
                      IsShredBoss(StyxWoW.Me.CurrentTarget) ||
                      TalentManager.Shred &&
                      (StyxWoW.Me.CachedHasAura(5217) || StyxWoW.Me.CachedHasAura(106951))))
                {
                    return mangle();
                }
            return false;
        }

        private static bool rake()
        {
            return !(target.distance > MeleeRange) && Spell.Cast("Rake");
        }

        private static bool treants()
        {
            if (Spell.GetSpellCooldown("Force of Nature").TotalSeconds > 1)
                return false;
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            if (SpellManager.CanCast("Force of Nature") && StyxWoW.Me.CurrentPendingCursorSpell == null &&
                (StyxWoW.Me.Location.Distance(StyxWoW.Me.CurrentTarget.Location) <=
                 SpellManager.Spells["Force of Nature"].MaxRange ||
                 SpellManager.Spells["Force of Nature"].MaxRange == 0))
            {
                SpellManager.Cast("Force of Nature");
            }
            SpellManager.ClickRemoteLocation(StyxWoW.Me.CurrentTarget.Location);
            LogAction("Force of Nature ", 2);
            Logging.Write(LogLevel.Normal, "Force of Nature");
            return true;
        }

        private static bool Mangle()
        {
            return !(target.distance > MeleeRange) && Spell.Cast(33878);
        }

        private static bool thrash_bear()
        {
            return !(target.distance > 8) && Spell.Cast(77758, true);
        }

        private static bool Lacerate()
        {
            return !(target.distance > MeleeRange) && Spell.Cast(33745, true);
        }

        private static bool Swipe()
        {
            return !(target.distance > 8) && Spell.Cast("Swipe", true);
        }

        private static bool Maul()
        {
            return !(target.distance > MeleeRange) && Spell.Cast(6807, true);
        }

        private static bool Barkskin()
        {
            return Spell.Heal("Barkskin", true);
        }

        private static bool enrage()
        {
            return Spell.Buff("Enrage", false);
        }

        private static bool Frenzied_Regeneration()
        {
            if (!SuperbadSettings.Instance.UseFrenziedRegen)
                return false;
            if (StyxWoW.Me.CurrentRage < 60)
                return false;
            if (StyxWoW.Me.Specialization == WoWSpec.DruidFeral)
                return Spell.Heal(22842, true);
            return Spell.Heal("Frenzied Regeneration", true);
        }

        private static bool Might_of_Ursoc()
        {
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                return false;
            return Spell.Heal("Might of Ursoc", true);
        }

        private static bool Survival_Instincts()
        {
            return Spell.Heal("Survival Instincts", true);
        }

        private static bool Wild_Charge()
        {
            if (!SuperbadSettings.Instance.UseBlink)
                return false;
            if (TalentManager.WildCharge)
                if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat || StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear)
                    if (StyxWoW.Me.CurrentTarget != null)
                        if (target.distance > 5 && target.distance < 25 &&
                            StyxWoW.Me.CurrentTarget.InLineOfSpellSight && StyxWoW.Me.CurrentTarget.InLineOfSight)
                            if (!Unit.IsAboveTheGround(StyxWoW.Me.CurrentTarget) &&
                                !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                            {
                                return Spell.CastTalent("Wild Charge", StyxWoW.Me.CurrentTarget);
                            }
            return false;
        }

        private static bool Displacer_Beast()
        {
            if (!SuperbadSettings.Instance.UseBlink)
                return false;
            if (TalentManager.DisplacerBeast)
                if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                    if (StyxWoW.Me.CurrentTarget != null)
                        if (!Unit.IsAboveTheGround(StyxWoW.Me.CurrentTarget) &&
                            !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                        {
                            return Spell.CastTalent("Displacer Beast", StyxWoW.Me.CurrentTarget);
                        }
            return false;
        }

        private static bool prowl()
        {
            if (BotPoi.Current.Type == PoiType.Loot || BotPoi.Current.Type == PoiType.Harvest ||
                BotPoi.Current.Type == PoiType.Skin)
            {
                return false;
            }
            if (SuperbadSettings.Instance.UseStealth)
            {
                return Spell.Buff("Prowl", true);
            }
            return false;
        }

        private static bool pounce()
        {
            return !(target.distance > MeleeRange) && Spell.Cast("Pounce", true);
        }

        private static bool bear_form()
        {
            if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear)
                return false;
            if (SuperbadSettings.Instance.Form == 3)
                return false;
            return Spell.Buff("Bear Form", false);
        }

        private static bool growl()
        {
            if (!SuperbadSettings.Instance.UseTaunt)
                return false;
            if (TankManager.Instance.NeedToTaunt.FirstOrDefault() != null)
                return Spell.Cast("Growl", true, TankManager.Instance.NeedToTaunt.FirstOrDefault());
            return false;
        }

        private static bool savage_defense()
        {
            if (!SuperbadSettings.Instance.UseSavageDefense)
                return false;
            if (StyxWoW.Me.CurrentRage >= 60)
                return Spell.Heal("Savage Defense", true);
            return false;
        }

        private static bool dash()
        {
            if (!SuperbadSettings.Instance.UseDash)
                return false;
            if (buff.darkflight.up || buff.stampeding_roar.up)
                return false;
            if (!Spell.DoubleCastEntries.ContainsKey("Speed"))
                if (Spell.Heal("Dash", true))
                {
                    Spell.UpdateDoubleCastEntries("Speed", 0.5);
                    return true;
                }
            return false;
        }

        private static bool stampeding_roar()
        {
            if (!SuperbadSettings.Instance.UseStampedingRoar)
                return false;
            if (buff.dash.up || buff.darkflight.up)
                return false;
            if (!Spell.DoubleCastEntries.ContainsKey("Speed"))
            {
                if (!buff.cat_form.down)
                    if (Spell.Buff(77764, true))
                    {
                        Spell.UpdateDoubleCastEntries("Speed", 0.5);
                        return true;
                    }
                if (!buff.bear_form.down)
                    if (Spell.Buff(77761, true))
                    {
                        Spell.UpdateDoubleCastEntries("Speed", 0.5);
                        return true;
                    }
            }
            return false;
        }

        private static bool renewal()
        {
            if (TalentManager.Renewal)
                return Spell.CastTalent("Renewal");
            return false;
        }

        private static bool cenarion_ward()
        {
            if (TalentManager.CenarionWard)
            {
                return Spell.CastTalent("Cenarion Ward");
            }
            return false;
        }

        private static bool escape()
        {
            if (!SuperbadSettings.Instance.Rooted)
                return false;
            if (Battlegrounds.IsInsideBattleground)
            {
                if (english)
                {
                    if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                        Lua.DoString("RunMacroText(\"/Cast !Cat Form\")");
                    if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear)
                        Lua.DoString("RunMacroText(\"/Cast !Bear Form\")");
                    Logging.Write(LogLevel.Normal, "Shift because i'm rooted!");
                    return true;
                }
                if (russian)
                {
                    if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                        Lua.DoString("RunMacroText(\"/Cast !Облик кошки\")");
                    if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear)
                        Lua.DoString("RunMacroText(\"/Cast !Облик медведя\")");
                    Logging.Write(LogLevel.Normal, "Shift because i'm rooted!");
                    return true;
                }
            }
            return false;
        }

        private static bool escapespeed()
        {
            if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Cat)
                if (dash())
                    return true;
            if (stampeding_roar())
                return true;
            return false;
        }

        private static bool mark_of_the_wild()
        {
            if (!HasSpellMarkoftheWild)
                return false;
            if (StyxWoW.Me.CurrentTarget != null)
                StyxWoW.Me.ClearTarget();
            return Spell.Buff("Mark of the Wild", StyxWoW.Me);
        }

        private static bool mighty_bash()
        {
            if (!SuperbadSettings.Instance.UseInterrupts)
                return false;
            if (StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget.IsPet)
                return false;
            if (StyxWoW.Me.Shapeshift != ShapeshiftForm.Cat && StyxWoW.Me.Shapeshift != ShapeshiftForm.Bear)
                return false;
            if (TalentManager.MightyBash)
                if (SuperbadSettings.Instance.MightyBash)
                    if (StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                        if (StyxWoW.Me.CurrentTarget.IsCasting && StyxWoW.Me.CurrentTarget.CanInterruptCurrentSpellCast &&
                            !Spell.DoubleCastEntries.ContainsKey("Interrupt"))
                        {
                            if (Spell.CastTalent("Mighty Bash"))
                            {
                                Spell.UpdateDoubleCastEntries("Interrupt", 0.5);
                                return true;
                            }
                        }
            return false;
        }

        public static bool IsShredBoss(WoWUnit unit)
        {
            return CanShredBoss.Contains(unit.Entry);
        }

        private static bool rejuvenation()
        {
            return Spell.Heal("Rejuvenation");
        }

        private static bool natures_grasp()
        {
            if (Unit.NearbyUnfriendlyUnits.Count(u => u.IsWithinMeleeRange) > 0)
                return Spell.Buff("Nature's Grasp", true);
            return false;
        }

        private static bool rake_cycle(WoWUnit unit)
        {
            if (!SuperbadSettings.Instance.RakeCycle)
                return false;
            if (unit == null)
                return false;
            if (unit != StyxWoW.Me.CurrentTarget && SuperbadSettings.Instance.UseTargeting)
            {
                unit.Target();
                unit.Face();
                return true;
            }
            return Spell.Cast("Rake", unit);
        }

        private static bool mangle()
        {
            return !(target.distance > MeleeRange) && Spell.Cast("Mangle");
        }

        private static bool moonfire()
        {
            return !(target.distance > 40) && Spell.Cast("Moonfire");
        }

        private static bool rebirth()
        {
            if (!SuperbadSettings.Instance.UseRebirth)
                return false;

            WoWPlayer woWPlayer;

            if (SuperbadSettings.Instance.RebirthMode == 0)
            {
                woWPlayer = Group.Tanks.FirstOrDefault(t => !t.IsMe && t.IsDead);
                if (woWPlayer == null)
                    return false;
                return !(woWPlayer.Distance >= 40) && Spell.Cast("Rebirth", true, woWPlayer);
            }
            if (SuperbadSettings.Instance.RebirthMode == 1)
            {
                woWPlayer = Group.Tanks.FirstOrDefault(t => !t.IsMe && t.IsDead) ??
                            Group.Healers.FirstOrDefault(h => !h.IsMe && h.IsDead);
                if (woWPlayer == null)
                    return false;
                return !(woWPlayer.Distance >= 40) && Spell.Cast("Rebirth", true, woWPlayer);
            }
            if (SuperbadSettings.Instance.RebirthMode == 2)
            {
                woWPlayer = (Group.Tanks.FirstOrDefault(t => !t.IsMe && t.IsDead) ??
                             Group.Healers.FirstOrDefault(h => !h.IsMe && h.IsDead)) ??
                            Group.Dps.FirstOrDefault(t => !t.IsMe && t.IsDead);
                if (woWPlayer == null)
                    return false;
                return !(woWPlayer.Distance >= 40) && Spell.Cast("Rebirth", true, woWPlayer);
            }
            if (SuperbadSettings.Instance.RebirthMode == 3)
            {
                woWPlayer = (WoWPlayer) StyxWoW.Me.FocusedUnit;
                if (woWPlayer == null)
                    return false;
                return !(woWPlayer.Distance >= 40) && Spell.Cast("Rebirth", true, woWPlayer);
            }
            return false;
        }


        /* SYMBIOSIS */

        private static bool ghost_wolfes()
        {
            if (!SuperbadSettings.Instance.Wolves)
                return false;
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.CurrentTarget != null && !target.IsBoss(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            if (HasSpellSymbiosisWolves)
            {
                return Spell.CastTalentBuff(110807);
            }
            return false;
        }

        private static bool soul_swap()
        {
            if (Spell.GetSpellCooldown(110810).TotalSeconds > 1)
                return false;
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            WoWUnit soulSwapTarget = null;
            soulSwapTarget = GetSoulSwapTarget(SoulSwapDebuffs);

            if (HasSpellSymbiosisSoulSwap)
            {
                SpellManager.Cast(110810);
                LogAction("Soul Swap" + " " + "", 1);
                return true;
            }
            return false;
        }

        private static WoWUnit GetSoulSwapTarget(string[] debuffs)
        {
            return StyxWoW.Me.CurrentTarget != null
                       ? Unit.NearbyAttackableUnits(StyxWoW.Me.CurrentTarget.Location, 15)
                             .FirstOrDefault(x => !x.HasAllAuras(debuffs) && (x.Distance < 40))
                       : null;
        }


        private static bool redirect()
        {
            if (Spell.GetSpellCooldown(110730).TotalSeconds > 1)
                return false;
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            if (HasSpellSymbiosisRedirect)
            {
                SpellManager.Cast(110730);
                LogAction("Soul Swap" + " " + "", 1);
                return true;
            }
            return false;
        }

        private static bool shattering_blow()
        {
            if (Spell.GetSpellCooldown(112997).TotalSeconds > 1)
                return false;
            if (StyxWoW.Me.CurrentTarget == null || !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange)
                return false;
            if (HasSpellSymbiosisShatteringBlow)
            {
                SpellManager.Cast(112997);
                LogAction("Soul Swap" + " " + "", 1);
                return true;
            }
            return false;
        }
    }
}