﻿#region

using System;
using Bots.BGBuddy.Helpers;
using McLovin;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.POI;
using Styx.WoWInternals;

#endregion

namespace Superbad
{
    public static class EventHandlers
    {
        public static bool startring = false;
        private static bool _combatLogAttached;
        public static double mastery;

        public static void Init()
        {
            AttachCombatLogEvent();
        }

        private static void AttachCombatLogEvent()
        {
            if (_combatLogAttached)
                return;

            // DO NOT EDIT THIS UNLESS YOU KNOW WHAT YOU'RE DOING!
            // This ensures we only capture certain combat log events, not all of them.
            // This saves on performance, and possible memory leaks. (Leaks due to Lua table issues.)
            Lua.Events.AttachEvent("COMBAT_LOG_EVENT_UNFILTERED", HandleCombatLog);
            if (
                !Lua.Events.AddFilter(
                    "COMBAT_LOG_EVENT_UNFILTERED",
                    "return args[2] == 'SPELL_AURA_APPLIED' or args[2] == 'SPELL_CAST_START' or args[2] == 'SPELL_DAMAGE' or args[2] == 'SPELL_AURA_REFRESH' or args[2] == 'SPELL_AURA_REMOVED'or args[2] == 'SPELL_MISSED' or args[2] == 'RANGE_MISSED' or args[2] =='SWING_MISSED'"))
            {
                Logger.Write(
                    "ERROR: Could not add combat log event filter! - Performance may be horrible, and things may not work properly!");
            }

            Logger.WriteDebug("Attached combat log");
            _combatLogAttached = true;
        }

        private static void DetachCombatLogEvent()
        {
            if (!_combatLogAttached)
                return;

            Logger.WriteDebug("Detached combat log");
            Lua.Events.DetachEvent("COMBAT_LOG_EVENT_UNFILTERED", HandleCombatLog);
            _combatLogAttached = false;
        }

        private static void HandleCombatLog(object sender, LuaEventArgs args)
        {
            var e = new CombatLogEventArgs(args.EventName, args.FireTimeStamp, args.Args);
            //Logger.WriteDebug("[CombatLog] " + e.Event + " - " + e.SourceName + " - " + e.SpellName);
            switch (e.Event)
            {
                case "SPELL_CAST_START":
                    if (e.SourceGuid != null && e.SourceGuid != 1 && e.SourceGuid == StyxWoW.Me.Guid)
                    {
                        //&& e.Timestamp == Lua.GetReturnVal<float>("return GetTime();", 0)
                        if (e.SpellId == 116011)
                        {
                            startring = true;
                            Logging.Write("Started to cast Rune of Power!");
                        }
                    }
                    break;

                case "SPELL_AURA_APPLIED":
                    if (e.SourceGuid != null && e.SourceGuid != 1 && e.SourceGuid == StyxWoW.Me.Guid)
                    {
                        if (e.SpellId == 1822)
                        {
                            // DO NOT EDIT THIS UNLESS YOU KNOW WHAT YOU'RE DOING!
                            // FOR FUCKS SAKE: THIS IS CORRECT! :O
                            Classname._dot_rake_multiplier = Classname.rake_calc;
                        }
                        if (e.SpellId == 106830)
                        {
                            // DO NOT EDIT THIS UNLESS YOU KNOW WHAT YOU'RE DOING!
                            // FOR FUCKS SAKE: THIS IS CORRECT! :O
                            Classname._dot_thrash_cat_multiplier = Classname.thrash_cat_calc;
                        }
                        if (e.SpellId == 1079)
                        {
                            // DO NOT EDIT THIS UNLESS YOU KNOW WHAT YOU'RE DOING!
                            // FOR FUCKS SAKE: THIS IS CORRECT! :O
                            Classname._ExtendedRip = 0;
                            Classname._dot_rip_multiplier = Classname.rip_calclogger;
                        }
                    }
                    break;

                case "SPELL_AURA_REFRESH":
                    if (e.SourceGuid != null && e.SourceGuid != 1 && e.SourceGuid == StyxWoW.Me.Guid)
                    {
                        if (e.SpellId == 1822)
                        {
                            // DO NOT EDIT THIS UNLESS YOU KNOW WHAT YOU'RE DOING!
                            // FOR FUCKS SAKE: THIS IS CORRECT! :O
                            Classname._dot_rake_multiplier = Classname.rake_calc;
                        }
                        if (e.SpellId == 1079)
                        {
                            // DO NOT EDIT THIS UNLESS YOU KNOW WHAT YOU'RE DOING!
                            // FOR FUCKS SAKE: THIS IS CORRECT! :O
                            Classname._ExtendedRip = 0;
                            Classname._dot_rip_multiplier = Classname.rip_calclogger;
                        }
                        if (e.SpellId == 106830)
                        {
                            // DO NOT EDIT THIS UNLESS YOU KNOW WHAT YOU'RE DOING!
                            // FOR FUCKS SAKE: THIS IS CORRECT! :O
                            Classname._dot_thrash_cat_multiplier = Classname.thrash_cat_calc;
                        }
                    }
                    break;

                case "SPELL_DAMAGE":
                    if (e.SourceGuid != null && e.SourceGuid != 1 && e.SourceGuid == StyxWoW.Me.Guid)
                    {
                        if (StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget.HasMyAura("Rip"))
                        {
                            if (e.SpellId == 5221 || e.SpellId == 114236 || e.SpellId == 102545 || e.SpellId == 33876)
                                //Normal Shred, Glyphed Shred, Ravage, Mangle
                                Classname._ExtendedRip = Classname._ExtendedRip + 1;
                        }
                    }
                    break;

                case "SPELL_AURA_REMOVED":
                    if (e.SourceGuid != null && e.SourceGuid != 1 && e.SourceGuid == StyxWoW.Me.Guid)
                    {
                        if (e.SpellId == 1822)
                        {
                            Classname._dot_rake_multiplier = 0;
                        }
                        if (e.SpellId == 1079)
                        {
                            Classname._ExtendedRip = 0;
                            Classname._dot_rip_multiplier = 0;
                        }
                        if (e.SpellId == 106830)
                        {
                            // DO NOT EDIT THIS UNLESS YOU KNOW WHAT YOU'RE DOING!
                            // FOR FUCKS SAKE: THIS IS CORRECT! :O
                            Classname._dot_thrash_cat_multiplier = 0;
                        }
                    }
                    break;

                case "SWING_MISSED":
                    if (e.Args[11].ToString() == "EVADE")
                    {
                        Logger.Write("Mob is evading swing. Blacklisting it!");
                        Blacklist.Add(e.DestGuid, TimeSpan.FromMinutes(30));
                        if (StyxWoW.Me.CurrentTargetGuid == e.DestGuid)
                        {
                            StyxWoW.Me.ClearTarget();
                        }

                        BotPoi.Clear("Blacklisting evading mob");
                        StyxWoW.SleepForLagDuration();
                    }
                    break;

                case "SPELL_MISSED":
                    break;
            }
        }
    }
}