﻿#region

using System;
using System.Linq;
using McLovin;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.WoWInternals;

#endregion

namespace Superbad
{
    public partial class Classname : CombatRoutine
    {
        private static readonly uint[] MageFoodIds = new uint[]
            {
                65500,
                65515,
                65516,
                65517,
                43518,
                43523,
                65499, //Conjured Mana Cake - Pre Cata Level 85
                80610, //Conjured Mana Pudding - MoP Lvl 85+
                80618 //Conjured Mana Buns 
                //This is where i made a change.
            };

        private static bool cold_snap()
        {
            return Spell.Buff("Cold Snap", true);
        }

        private static bool cancel_buff()
        {
            if (buff.alter_time.up)
            {
                var name = ("Alter Time");
                var macro = String.Format("/cancelaura {0}", name);
                Lua.DoString("RunMacroText(\"" + RealLuaEscape(macro) + "\")");
                return true;
            }
            return false;
        }

        private static bool conjure_mana_gem()
        {
            if (!SpellManager.HasSpell(759))
                return false;
            if (StyxWoW.Me.IsMoving)
                return false;
            var gem = StyxWoW.Me.BagItems.FirstOrDefault(i => i.Entry == 36799 || i.Entry == 81901);
            if (gem != null)
                return false;
            return Spell.Buff(759, StyxWoW.Me);
        }

        private static bool time_warp()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.CurrentTarget != null && !target.IsBoss(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (StyxWoW.Me.HasAura("Temporal Displacement") || StyxWoW.Me.HasAura("Exhaustion"))
                return false;
            if (target.time_to_die <= 25)
                return false;
            return Spell.Buff("Time Warp", true);
        }

        private static bool presence_of_mind()
        {
            if (StyxWoW.Me.HasAura(12043))
                return false;
            if (target.time_to_die <= 10)
                return false;
            return Spell.Buff("Presence of Mind", true);
        }

        private static bool water_elemental_freeze()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (!StyxWoW.Me.Mounted && !StyxWoW.Me.CurrentTarget.HasAura("Frost Nova") && StyxWoW.Me.GotAlivePet &&
                StyxWoW.Me.Pet.ManaPercent >= 12)
            {
                if (PetManager.CanCastPetAction("Freeze"))
                {
                    PetManager.CastPetAction("Freeze");
                    SpellManager.ClickRemoteLocation(StyxWoW.Me.CurrentTarget.Location);
                    LogAction("Freeze - Water Elemental", 0);
                    return true;
                }
            }
            return false;
        }

        private static bool icy_veins()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.CurrentTarget != null && !target.IsBoss(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (target.time_to_die <= 20)
                return false;
            if (TalentManager.HasGlyph("Icy Veins"))
                return Spell.Buff(131078, true);
            return Spell.Buff("Icy Veins", true);
        }

        private static bool frostfire_bolt()
        {
            return Spell.Cast("Frostfire Bolt", StyxWoW.Me.CurrentTarget);
        }

        private static bool ice_lance()
        {
            return Spell.Cast("Ice Lance", StyxWoW.Me.CurrentTarget);
        }

        private static bool frostbolt()
        {
            if (StyxWoW.Me.IsMoving && !buff.presence_of_mind.up)
                return false;
            return Spell.Cast("Frostbolt", StyxWoW.Me.CurrentTarget);
        }

        private static bool frozen_orb()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.CurrentTarget.Distance > 30)
                return false;
            if (target.time_to_die <= 6)
                return false;
            return Spell.Cast("Frozen Orb", true, StyxWoW.Me.CurrentTarget);
        }

        private static bool frost_bomb()
        {
            if (StyxWoW.Me.IsMoving && !buff.presence_of_mind.up)
                return false;
            return Spell.Cast(112948, true, StyxWoW.Me.CurrentTarget);
        }

        private static bool mirror_image()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.CurrentTarget != null && !target.IsBoss(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (target.time_to_die <= 25)
                return false;
            return Spell.Buff("Mirror Image", true);
        }

        private static bool evocation()
        {
            if (StyxWoW.Me.IsMoving)
                return false;
            return Spell.Buff("Evocation", true);
        }

        private static bool alter_time()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.IsInInstance && StyxWoW.Me.CurrentTarget != null && !target.IsBoss(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (target.time_to_die <= 25)
                return false;
            return Spell.Buff("Alter Time", true);
        }

        private static bool mana_gem()
        {
            var gem = StyxWoW.Me.BagItems.FirstOrDefault(i => i.Entry == 36799 || i.Entry == 81901);
            if (gem == null || gem.Cooldown != 0)
                return false;
            gem.Use();
            LogAction("Using Mana Gem", 1);
            return true;
        }

        private static bool fire_blast()
        {
            return Spell.Cast("Fire Blast", true, StyxWoW.Me.CurrentTarget);
        }

        private static bool iceblock()
        {
            if (!SpellManager.HasSpell("Ice Block"))
                return false;
            if (SpellManager.Spells["Ice Block"].CooldownTimeLeft.TotalSeconds >
                SpellManager.GlobalCooldownLeft.TotalSeconds)
                return false;
            if (StyxWoW.Me.HealthPercent < 10)
            {
                SpellManager.Cast("Ice Block");
                Logging.Write(LogLevel.Normal, "Ice Block");
                return true;
            }
            return false;
        }

        private static bool ice_barrier()
        {
            if (StyxWoW.Me.CurrentTarget != null && target.IsTrainingDummy(StyxWoW.Me.CurrentTarget))
                return false;
            return Spell.Buff("Ice Barrier", StyxWoW.Me);
        }

        private static bool deep_freeze()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.IsInInstance || target.IsTrainingDummy(StyxWoW.Me.CurrentTarget))
                return false;
            if (!SpellManager.HasSpell("Deep Freeze"))
                return false;
            if (SpellManager.Spells["Deep Freeze"].CooldownTimeLeft.TotalSeconds >
                SpellManager.GlobalCooldownLeft.TotalSeconds)
                return false;
            if (StyxWoW.Me.ActiveAuras.ContainsKey("Fingers of Frost") ||
                StyxWoW.Me.CurrentTarget.HasAura("Freeze") ||
                StyxWoW.Me.CurrentTarget.HasAura("Frost Nova"))
            {
                SpellManager.Cast("Deep Freeze");
                Logging.Write(LogLevel.Normal, "Deep Freeze");
                return true;
            }
            return false;
        }

        private static bool frost_nova()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.CurrentTarget.IsBoss || target.IsTrainingDummy(StyxWoW.Me.CurrentTarget))
                return false;
            if (Unit.NearbyUnfriendlyUnits.Any(u => u.Distance <= 11 && !u.HasAura("Frost Nova") && !u.HasAura("Freeze")))
            {
                if (!SpellManager.HasSpell("Frost Nova"))
                    return false;
                if (SpellManager.Spells["Frost Nova"].CooldownTimeLeft.TotalSeconds >
                    SpellManager.GlobalCooldownLeft.TotalSeconds)
                    return false;
                SpellManager.Cast("Frost Nova");
                Logging.Write(LogLevel.Normal, "Frost Nova");
                return true;
            }
            return false;
        }

        private static bool sheep()
        {
            if (StyxWoW.Me.IsMoving)
                return false;
            if (StyxWoW.Me.IsInInstance)
                return false;
            if (!SpellManager.HasSpell("Polymorph"))
                return false;
            if (Unit.NearbyUnfriendlyUnits.Count() >= 2)
            {
                var sheepTarget =
                    Unit.NearbyUnfriendlyUnits.OrderByDescending(u => u.CurrentHealth).FirstOrDefault(
                        Unit.IsViableForPolymorph);
                if (
                    Unit.NearbyUnfriendlyUnits.All(
                        u =>
                        u.GetAllAuras().FirstOrDefault(a => a.Name == "Polymorph" && (a.CreatorGuid == StyxWoW.Me.Guid)) ==
                        null))
                {
                    if (sheepTarget != null && sheepTarget != StyxWoW.Me.CurrentTarget)
                    {
                        SpellManager.Cast("Polymorph", sheepTarget);
                        Logging.Write(LogLevel.Normal, "Polymorph");
                        return true;
                    }
                }
            }
            return false;
        }

        private static bool ring_of_frost()
        {
            if (StyxWoW.Me.CurrentTarget == null)
                return false;
            if (StyxWoW.Me.CurrentTarget.IsBoss)
                return false;
            if (!SpellManager.HasSpell("Ring of Frost"))
                return false;
            if (WoWSpell.FromId(113724).CooldownTimeLeft.TotalSeconds > SpellManager.GlobalCooldownLeft.TotalSeconds)
                return false;
            SpellManager.Cast("Ring of Frost", StyxWoW.Me.CurrentTarget);
            //SpellManager.ClickRemoteLocation(StyxWoW.Me.CurrentTarget.Location);
            Logging.Write(LogLevel.Normal, "Ring of Frost");
            return true;
        }

        private static bool blink()
        {
            if (StyxWoW.Me.IsInInstance)
                return false;
            if (!SpellManager.HasSpell("Blink"))
                return false;
            if (SpellManager.Spells["Blink"].CooldownTimeLeft.TotalSeconds >
                SpellManager.GlobalCooldownLeft.TotalSeconds)
                return false;
            SpellManager.Cast("Blink");
            Logging.Write(LogLevel.Normal, "Blink");
            return true;
        }

        private static bool arcane_brilliance()
        {
            if (StyxWoW.Me.CurrentTarget != null)
                StyxWoW.Me.ClearTarget();
            return Spell.Buff("Arcane Brilliance", StyxWoW.Me);
        }

        private static bool conjure_refreshment()
        {
            var gotFood = StyxWoW.Me.BagItems.Any(item => MageFoodIds.Contains(item.Entry));
            if (!gotFood)
            {
                return Spell.Cast("Conjure Refreshment");
            }
            return false;
        }

        private static bool frost_armor()
        {
            return Spell.Buff("Frost Armor", StyxWoW.Me);
        }

        private static bool callPet()
        {
            if (!StyxWoW.Me.GotAlivePet && PetManager.PetTimer.IsFinished &&
                SpellManager.CanCast("Summon Water Elemental"))
            {
                return PetManager.CallPet("Summon Water Elemental");
            }
            return false;
        }

        private static bool arcane_power()
        {
            return Spell.Buff("Arcane Power", true);
        }

        private static bool arcane_blast()
        {
            if (StyxWoW.Me.IsMoving)
                return false;
            return Spell.Cast("Arcane Blast", StyxWoW.Me.CurrentTarget);
        }

        private static bool arcane_missiles()
        {
            if (StyxWoW.Me.IsMoving)
                return false;
            return Spell.Cast("Arcane Missiles", StyxWoW.Me.CurrentTarget);
        }

        private static bool rune_of_power()
        {
            if (target.time_to_die <= 10)
                return false;
            if (!onerune)
            {
                if (Spell.Buff("Rune of Power", StyxWoW.Me))
                {
                    SpellManager.ClickRemoteLocation(StyxWoW.Me.Location);
                    onerune = true;
                    return true;
                }
            }
            return false;
        }

        private static bool arcane_barrage()
        {
            return Spell.Cast("Arcane Barrage", true, StyxWoW.Me.CurrentTarget);
        }

        private static bool living_bomb()
        {
            return Spell.Cast("Living Bomb", true, StyxWoW.Me.CurrentTarget);
        }

        private bool mage_armor()
        {
            return Spell.Buff("Mage Armor", StyxWoW.Me);
        }

        private static bool scorch()
        {
            return Spell.Cast("Scorch", StyxWoW.Me.CurrentTarget);
        }

        private static bool nether_tempest()
        {
            if (StyxWoW.Me.IsMoving && !buff.presence_of_mind.up)
                return false;
            return Spell.Cast(114923, true, StyxWoW.Me.CurrentTarget);
        }

        private static bool flamestrike()
        {
            if (Spell.Cast("Flamestrike", true))
            {
                SpellManager.ClickRemoteLocation(StyxWoW.Me.CurrentTarget.Location);
                return true;
            }
            return false;
        }

        private static bool arcane_explosion()
        {
            return Spell.Cast("Arcane Explosion", StyxWoW.Me.CurrentTarget);
        }
    }
}