﻿#region

using System;
using System.Linq;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using McLovin;
using Styx;
using Styx.Common;
using Styx.Common.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Inventory;
using Styx.CommonBot.POI;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

#endregion

namespace Superbad
{
    [Flags]
    public enum WoWContext
    {
        None = 0,
        Normal = 0x1,
        Instances = 0x2,
        Battlegrounds = 0x4,

        All = Normal | Instances | Battlegrounds,
    }

    public partial class Classname : CombatRoutine
    {
        /* HasSpellChecks! */
        public static bool HasSpellDash;
        public static bool HasSpellHealingTouch;
        public static bool HasSpellProwl;
        public static bool HasSpellMarkoftheWild;
        public static bool HasSpellAquaticForm;
        public static bool HasSpellSavageRoar;

        public static bool HasSpellSymbiosisWolves;
        public static bool HasSpellSymbiosisSoulSwap;
        public static bool HasSpellSymbiosisRedirect;
        public static bool HasSpellSymbiosisShatteringBlow;


        public static bool english;
        public static bool russian;

        public static bool EnableMovement;
        public static WoWUnit taunt;
        public static double mastery;
        public static double anticipation_charges;
        public static bool position_front;
        public static bool Paused = false;

        public static bool debug = false;

        public static double mana_gem_charges;
        public static double gcd;
        public static bool ticking;

        //TODO: add tick time, remains and ticking for arcane!
        public static double tick_time;
        public static double remains;

        public static WaitTimer RuneTimer = new WaitTimer(TimeSpan.FromSeconds(58.5));
        public static double runeleft;
        public WaitTimer CheckTimer = new WaitTimer(TimeSpan.FromSeconds(5));
        public bool timer = true;

        public override string Name
        {
            get { return "Superbad v 2.0"; }
        }

        public override WoWClass Class
        {
            get
            {
                if (StyxWoW.Me.Class == WoWClass.Druid)
                    return WoWClass.Druid;
                if (StyxWoW.Me.Class == WoWClass.Mage)
                    return WoWClass.Mage;
                return WoWClass.None;
            }
        }

        public static float MeleeRange
        {
            get
            {
                if (StyxWoW.Me.CurrentTarget == null)
                    return 0f;
                if (StyxWoW.Me.CurrentTargetGuid == 0)
                    return 0f;
                return StyxWoW.Me.CurrentTarget.IsPlayer
                           ? 3.5f
                           : Math.Max(5f, StyxWoW.Me.CombatReach + 1.3333334f + StyxWoW.Me.CurrentTarget.CombatReach);
            }
        }


        public override bool WantButton
        {
            get { return true; }
        }

        public override bool NeedRest
        {
            get
            {
                if (StyxWoW.Me.Pacified)
                    return false;
                if (StyxWoW.Me.Combat)
                    return false;
                resetVariables();
                if (StyxWoW.Me.IsFlying && StyxWoW.Me.IsOnTransport)
                    return false;
                if (StyxWoW.Me.Class == WoWClass.Mage)
                {
                    if (!StyxWoW.Me.IsDead && !StyxWoW.Me.IsGhost && !StyxWoW.Me.IsCasting && !StyxWoW.Me.Mounted)
                    {
                        if ((StyxWoW.Me.CachedHasAura("Food") && StyxWoW.Me.HealthPercent < 95) ||
                            (StyxWoW.Me.CachedHasAura("Drink") && StyxWoW.Me.ManaPercent < 95))
                            return true;
                        if (!StyxWoW.Me.CachedHasAura("Arcane Brilliance") &&
                            !StyxWoW.Me.CachedHasAura("Fel Intelligence"))
                            if (arcane_brilliance())
                                return true;
                        if (StyxWoW.Me.Specialization == WoWSpec.MageFrost)
                        {
                            if (!StyxWoW.Me.HasAura("Ice Barrier"))
                                if (ice_barrier())
                                    return true;
                            if (!StyxWoW.Me.HasAura("Frost Armor"))
                                if (frost_armor())
                                    return true;

                            if (callPet())
                                return true;
                        }
                        if (StyxWoW.Me.Specialization == WoWSpec.MageArcane)
                        {
                            if (!StyxWoW.Me.HasAura("Mage Armor"))
                                if (mage_armor())
                                    return true;
                        }

                        if (conjure_refreshment())
                            return true;
                        if (conjure_mana_gem())
                            return true;
                        if (!StyxWoW.Me.IsSwimming && StyxWoW.Me.HealthPercent <= 50 &&
                            !StyxWoW.Me.CachedHasAura("Food") &&
                            Consumable.GetBestFood(false) != null)
                        {
                            return true;
                        }

                        if (!StyxWoW.Me.IsSwimming &&
                            StyxWoW.Me.ManaPercent <= 50 &&
                            !StyxWoW.Me.CachedHasAura("Drink") && Consumable.GetBestDrink(false) != null)
                        {
                            return true;
                        }
                    }
                }
                if (StyxWoW.Me.Class == WoWClass.Druid)
                {
                    if (!StyxWoW.Me.IsDead && !StyxWoW.Me.IsGhost && !StyxWoW.Me.IsCasting && !StyxWoW.Me.Mounted &&
                        StyxWoW.Me.Shapeshift != ShapeshiftForm.EpicFlightForm &&
                        StyxWoW.Me.Shapeshift != ShapeshiftForm.FlightForm)
                    {
                        if (!StyxWoW.Me.CachedHasAura("Drink") && !StyxWoW.Me.CachedHasAura("Food"))
                        {
                            if (buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 &&
                                HasSpellHealingTouch)
                                return true;
                            if (SuperbadSettings.Instance.WaitSickness && buff.resurrection_sickness.up)
                                return true;
                            if (StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.OoCReju && !buff.rejuvenation.up)
                                return true;
                            if (StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.OoCHealingTouch)
                                return true;
                            //if (!buff.alchemists_flask.up)
                            //    return true;
                            if (SuperbadSettings.Instance.SavageFarm)
                                if (!buff.cat_form.down)
                                    if (buff.savage_roar.down)
                                    {
                                        if (savage_roar())
                                            return true;
                                    }
                        }
                        if (!StyxWoW.Me.IsSwimming && StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.RestHealth &&
                            !StyxWoW.Me.CachedHasAura("Food") && Consumable.GetBestFood(false) != null)
                            return true;
                        if (!StyxWoW.Me.IsSwimming &&
                            StyxWoW.Me.ManaPercent <= SuperbadSettings.Instance.RestMana &&
                            !StyxWoW.Me.CachedHasAura("Drink") && Consumable.GetBestDrink(false) != null)
                            return true;
                        if (!StyxWoW.Me.CachedHasAura("Drink") && !StyxWoW.Me.CachedHasAura("Food"))
                        {
                            if (SuperbadSettings.Instance.Mdw)
                                if (buff.mark_of_the_wild.down && HasSpellMarkoftheWild)
                                    return true;
                            if (SuperbadSettings.Instance.Mdwgroup)
                                if (PartyBuff.needGrpBuff())
                                    return true;
                        }
                        if ((StyxWoW.Me.CachedHasAura("Food") && StyxWoW.Me.HealthPercent < 95) ||
                            (StyxWoW.Me.CachedHasAura("Drink") && StyxWoW.Me.ManaPercent < 95))
                            return true;
                        if (((StyxWoW.Me.ManaPercent <= SuperbadSettings.Instance.RestMana) ||
                             StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.RestHealth) &&
                            !StyxWoW.Me.CurrentMap.IsBattleground)
                            return true;
                        if (StyxWoW.Me.IsSwimming
                            && StyxWoW.Me.Shapeshift != ShapeshiftForm.Aqua)
                            return true;
                        if (!StyxWoW.Me.CachedHasAura("Drink") && !StyxWoW.Me.CachedHasAura("Food"))
                        {
                            if (SuperbadSettings.Instance.StayInStealth && !buff.prowl.up && !StyxWoW.Me.Mounted &&
                                StyxWoW.Me.Shapeshift != ShapeshiftForm.Aqua && cooldown.prowl < 1)
                                return true;
                        }
                    }
                }
                return false;
            }
        }

        public static void SetLearnedSpells()
        {
            HasSpellDash = SpellManager.HasSpell("Dash");
            HasSpellHealingTouch = SpellManager.HasSpell("Healing Touch");
            HasSpellProwl = SpellManager.HasSpell("Prowl");
            HasSpellMarkoftheWild = SpellManager.HasSpell("Mark of the Wild");
            HasSpellAquaticForm = SpellManager.HasSpell("Aquatic Form");
            HasSpellSavageRoar = SpellManager.HasSpell("Savage Roar");
            HasSpellSymbiosisWolves = SpellManager.HasSpell(110807);
            HasSpellSymbiosisSoulSwap = SpellManager.HasSpell(110810);
            HasSpellSymbiosisRedirect = SpellManager.HasSpell(110730);
            HasSpellSymbiosisShatteringBlow = SpellManager.HasSpell(112997);
        }


        public override void Rest()
        {
            if (StyxWoW.Me.Pacified)
                return;
            resetVariables();
            if (StyxWoW.Me.IsFlying && StyxWoW.Me.IsOnTransport)
                return;
            if (StyxWoW.Me.Class == WoWClass.Mage)
            {
                if (!StyxWoW.Me.CachedHasAura("Arcane Brilliance") && !StyxWoW.Me.CachedHasAura("Fel Intelligence"))
                    if (arcane_brilliance())
                        return;
                if (StyxWoW.Me.Specialization == WoWSpec.MageFrost)
                {
                    if (!StyxWoW.Me.HasAura("Ice Barrier"))
                        if (ice_barrier())
                            return;
                    if (!StyxWoW.Me.HasAura("Frost Armor"))
                        if (frost_armor())
                            return;
                    if (callPet())
                        return;
                }
                if (StyxWoW.Me.Specialization == WoWSpec.MageArcane)
                {
                    if (!StyxWoW.Me.HasAura("Mage Armor"))
                        if (mage_armor())
                            return;
                }

                if (conjure_refreshment())
                    return;
                if (conjure_mana_gem())
                    return;
                if (!StyxWoW.Me.IsSwimming && StyxWoW.Me.HealthPercent <= 50 &&
                    !StyxWoW.Me.CachedHasAura("Food") &&
                    Consumable.GetBestFood(false) != null)
                {
                    if (StyxWoW.Me.IsMoving)
                        Navigator.PlayerMover.MoveStop();
                    Styx.CommonBot.Rest.FeedImmediate();
                }

                if (!StyxWoW.Me.IsSwimming &&
                    StyxWoW.Me.ManaPercent <= 50 &&
                    !StyxWoW.Me.CachedHasAura("Drink") && Consumable.GetBestDrink(false) != null)
                {
                    if (StyxWoW.Me.IsMoving)
                        Navigator.PlayerMover.MoveStop();
                    Styx.CommonBot.Rest.DrinkImmediate();
                }
            }

            if (StyxWoW.Me.Class == WoWClass.Druid)
            {
                if (!StyxWoW.Me.CachedHasAura("Drink") && !StyxWoW.Me.CachedHasAura("Food"))
                {
                    if (buff.predatory_swiftness.up && buff.predatory_swiftness.remains > 0.2 && HasSpellHealingTouch)
                    {
                        if (healing_touch())
                            return;
                    }
                    if (StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.OoCReju && !buff.rejuvenation.up)
                        if (rejuvenation())
                            return;
                    if (StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.OoCHealingTouch)
                    {
                        if (healing_touch())
                            return;
                    }
                    // if (!buff.alchemists_flask.up)
                    //    if(flask())
                    //       return;
                    if (SuperbadSettings.Instance.SavageFarm)
                        if (!buff.cat_form.down)
                            if (buff.savage_roar.down)
                            {
                                if (savage_roar())
                                    return;
                            }
                }
                if (!StyxWoW.Me.IsSwimming && StyxWoW.Me.HealthPercent <= SuperbadSettings.Instance.RestHealth &&
                    !StyxWoW.Me.CachedHasAura("Food") &&
                    Consumable.GetBestFood(false) != null)
                {
                    if (StyxWoW.Me.IsMoving)
                        Navigator.PlayerMover.MoveStop();
                    Styx.CommonBot.Rest.FeedImmediate();
                }

                if (!StyxWoW.Me.IsSwimming &&
                    StyxWoW.Me.ManaPercent <= SuperbadSettings.Instance.RestMana &&
                    !StyxWoW.Me.CachedHasAura("Drink") && Consumable.GetBestDrink(false) != null)
                {
                    if (StyxWoW.Me.IsMoving)
                        Navigator.PlayerMover.MoveStop();
                    Styx.CommonBot.Rest.DrinkImmediate();
                }

                if (!StyxWoW.Me.CachedHasAura("Drink") && !StyxWoW.Me.CachedHasAura("Food"))
                {
                    if (SuperbadSettings.Instance.Mdw)
                        if (buff.mark_of_the_wild.down)
                            if (mark_of_the_wild())
                                return;
                    if (SuperbadSettings.Instance.Mdwgroup)
                        if (PartyBuff.needGrpBuff())
                            if (mark_of_the_wild())
                                return;
                    if (StyxWoW.Me.IsSwimming
                        && StyxWoW.Me.Shapeshift != ShapeshiftForm.Aqua)
                        if (aquatic_form())
                            return;

                    if (SuperbadSettings.Instance.StayInStealth && !buff.prowl.up && !StyxWoW.Me.Mounted &&
                        StyxWoW.Me.Shapeshift != ShapeshiftForm.Aqua && cooldown.prowl < 1)
                        if (prowl())
                            return;
                }
            }
        }


        [DllImport("user32.dll")]
        private static extern short GetAsyncKeyState(Keys vKey);

        public override void Pulse()
        {
            if (!StyxWoW.IsInGame || !StyxWoW.IsInWorld)
                return;
            if (StyxWoW.Me.Class == WoWClass.Druid)
            {
                if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear)
                {
                    TankManager.Instance.Pulse();
                }
                if (StyxWoW.Me.CurrentTarget != null)
                    DpsMeter.Update();
                Spell.PulseDoubleCastEntries();
            }
            if (StyxWoW.Me.Class == WoWClass.Mage)
            {
                if (StyxWoW.Me.Specialization == WoWSpec.MageArcane)
                {
                    if (EventHandlers.startring)
                    {
                        RuneTimer.Reset();
                        EventHandlers.startring = false;
                    }

                    if (StyxWoW.Me.BagItems.FirstOrDefault(i => i.Entry == 36799 || i.Entry == 81901) != null)
                        mana_gem_charges = 1;
                    if (StyxWoW.Me.BagItems.FirstOrDefault(i => i.Entry == 36799 || i.Entry == 81901) == null)
                        mana_gem_charges = 0;

                    if (StyxWoW.Me.CurrentTarget != null)
                    {
                        ticking = StyxWoW.Me.CurrentTarget.HasMyAura("Nether Tempest");
                        remains = Spell.GetMyAuraTimeLeft("Nether Tempest", StyxWoW.Me.CurrentTarget);
                        if (ticking)
                        {
                            var Living = StyxWoW.Me.CurrentTarget.GetAllAuras().FirstOrDefault(
                                a => a.Name == "Nether Tempest" && (a.CreatorGuid == StyxWoW.Me.Guid));
                            if (Living != null)
                            {
                                var multiplier = (float) 0.001;
                                //Logging.Write("Lua dura: " +Living.Duration*multiplier);
                                var Duration = Living.Duration*multiplier;
                                tick_time = Duration/4;
                            }
                        }
                    }
                }

                if (StyxWoW.Me.Specialization == WoWSpec.MageFrost)
                {
                    gcd = SpellManager.GlobalCooldownLeft.TotalSeconds;

                    if (StyxWoW.Me.CurrentTarget != null)
                    {
                        ticking = StyxWoW.Me.CurrentTarget.HasMyAura("Nether Tempest");
                        remains = Spell.GetMyAuraTimeLeft("Nether Tempest", StyxWoW.Me.CurrentTarget);
                        if (ticking)
                        {
                            var Living = StyxWoW.Me.CurrentTarget.GetAllAuras().FirstOrDefault(
                                a => a.Name == "Nether Tempest" && (a.CreatorGuid == StyxWoW.Me.Guid));
                            if (Living != null)
                            {
                                var multiplier = (float) 0.001;
                                //Logging.Write("Lua dura: " +Living.Duration*multiplier);
                                var Duration = Living.Duration*multiplier;
                                tick_time = Duration/4;
                            }
                        }
                    }
                    PetManager.Pulse();
                }

                if (!StyxWoW.Me.Combat)
                {
                    setStartTime = false;
                }
            }
        }

        public override void OnButtonPress()
        {
            Logging.Write("Config opened!");
            //new SuperbadConfig().ShowDialog();
            new newSuperbadConfig().ShowDialog();
        }

        public override void Initialize()
        {
            Logging.Write("");
            Logging.Write("Hello " + StyxWoW.Me.Race + " " + StyxWoW.Me.Class);
            Logging.Write("Thank you for using Superbad");
            Logging.Write("");
            TalentManager.Update();
            Logging.Write("Using " + StyxWoW.Me.Specialization + " optimized rotations!");
            EventHandlers.Init();
            Updater.CheckForUpdate();
            Lua.Events.AttachEvent("MODIFIER_STATE_CHANGED", HandleModifierStateChanged);
            var localeLanguage = Lua.GetReturnVal<string>("return GetLocale();", 0);

            if (localeLanguage == "enGB" || localeLanguage == "enUS")
            {
                english = true;
                Logging.Write("Detected client with english language.");
            }
            if (localeLanguage == "ruRU")
            {
                russian = true;
                Logging.Write("Detected client with russian language.");
            }
            SetLearnedSpells();
        }

        public override void ShutDown()
        {
            Lua.Events.DetachEvent("MODIFIER_STATE_CHANGED", HandleModifierStateChanged);
        }

        private void HandleModifierStateChanged(object sender, LuaEventArgs args)
        {
            if (SuperbadSettings.Instance.PauseKey == SuperbadSettings.Keypress.None)
                return;

            if (Convert.ToInt32(args.Args[1]) == 1)
            {
                if (args.Args[0].ToString() == SuperbadSettings.Instance.PauseKey.ToString())
                {
                    Paused = !Paused;
                    if (Paused)
                    {
                        Logging.Write("Superbad PAUSED, press {0} in WOW to continue",
                                      SuperbadSettings.Instance.PauseKey.ToString());
                        if (SuperbadSettings.Instance.PrintMsg)
                            Lua.DoString(
                                "RaidNotice_AddMessage(RaidWarningFrame, \"Superbad PAUSED\", ChatTypeInfo[\"RAID_WARNING\"]);");
                    }
                    else
                    {
                        Logging.Write("Superbad Running....");
                        if (SuperbadSettings.Instance.PrintMsg)
                            Lua.DoString(
                                "RaidNotice_AddMessage(RaidWarningFrame, \"Superbad Resumed\", ChatTypeInfo[\"RAID_WARNING\"]);");
                    }
                }
            }
        }

        public override void Pull()
        {
            resetVariables();
            if (SuperbadSettings.Instance.UseTargeting)
                EnsureTarget();
            //Getting away from frozen Target
            if (StyxWoW.Me.Specialization == WoWSpec.MageFrost)
            {
                var runaway = Unit.NearbyUnfriendlyUnits.Where(
                    u => (u.CachedHasAura("Frost Nova") || u.CachedHasAura("Freeze")) &&
                         u.Distance < Unit.MeleeRange).
                                   OrderBy(u => u.DistanceSqr).FirstOrDefault();
                if (runaway != null)
                {
                    if (blink())
                        return;
                    var moveTo =
                        WoWMathHelper.CalculatePointBehind(
                            (runaway).Location,
                            (runaway).Rotation,
                            -(Unit.MeleeRange + 5f));
                    if (Navigator.CanNavigateFully(StyxWoW.Me.Location, moveTo))
                    {
                        Logging.Write("Getting away from frozen target");
                        Navigator.MoveTo(moveTo);
                        return;
                    }
                }
            }
            //MoveToLos
            if (SuperbadSettings.Instance.UseMovement)
            {
                if (StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget != StyxWoW.Me &&
                    !StyxWoW.Me.CurrentTarget.InLineOfSight)
                    Navigator.MoveTo(StyxWoW.Me.CurrentTarget.Location);
                //FaceTarget
                if (StyxWoW.Me.CurrentTarget != null && !StyxWoW.Me.IsMoving && !StyxWoW.Me.CurrentTarget.IsMe &&
                    !StyxWoW.Me.IsSafelyFacing(StyxWoW.Me.CurrentTarget, 70f))
                    StyxWoW.Me.CurrentTarget.Face();
                //MoveToMelee
                if (StyxWoW.Me.Class == WoWClass.Mage)
                {
                    if (StyxWoW.Me.CurrentTarget != StyxWoW.Me && !StyxWoW.Me.IsCasting &&
                        StyxWoW.Me.CurrentTarget != null)
                    {
                        if (StyxWoW.Me.Location.Distance(StyxWoW.Me.CurrentTarget.Location) < 39f)
                        {
                            if (StyxWoW.Me.IsMoving)
                            {
                                Navigator.PlayerMover.MoveStop();
                            }
                        }
                        else
                        {
                            Navigator.MoveTo(StyxWoW.Me.CurrentTarget.Location);
                        }
                    }
                }

                if (StyxWoW.Me.Class == WoWClass.Druid)
                {
                    if (!StyxWoW.Me.IsCasting)
                    {
                        var range = StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget.IsPlayer
                                        ? 2f
                                        : MeleeRange;
                        if (StyxWoW.Me.CurrentTarget != null &&
                            StyxWoW.Me.Location.Distance(StyxWoW.Me.CurrentTarget.Location) < range)
                        {
                            if (StyxWoW.Me.IsMoving)
                            {
                                Navigator.PlayerMover.MoveStop();
                            }
                        }
                        else
                        {
                            if (StyxWoW.Me.CurrentTarget != null)
                                Navigator.MoveTo(StyxWoW.Me.CurrentTarget.Location);
                        }
                    }
                    //MoveBehind
                    if (StyxWoW.Me.CurrentTarget != null &&
                        ((StyxWoW.Me.IsInInstance && !StyxWoW.Me.CurrentTarget.IsTargetingMeOrPet)) || buff.prowl.up)
                    {
                        if (StyxWoW.Me.CurrentTarget != null && (!StyxWoW.Me.IsCasting &&
                                                                 StyxWoW.Me.Role != WoWPartyMember.GroupRole.Tank &&
                                                                 !StyxWoW.Me.CurrentTarget.MeIsBehind &&
                                                                 StyxWoW.Me.CurrentTarget.IsAlive
                                                                ))
                        {
                            Navigator.MoveTo(CalculatePointBehindTarget());
                        }
                    }
                }
            }
            if (StyxWoW.Me.Specialization == WoWSpec.MageFrost)
            {
                FrostPull();
                return;
            }
            if (StyxWoW.Me.Specialization == WoWSpec.MageArcane)
            {
                ArcanePull();
                return;
            }

            if (WoWSpec.DruidFeral == StyxWoW.Me.Specialization)
                FeralPull();
            if (WoWSpec.DruidGuardian == StyxWoW.Me.Specialization)
                GuardianPull();
        }


        public override void Combat()
        {
            resetVariables();
            if (Paused)
                return;
            if (BotManager.Current.Name == "Gatherbuddy" &&
                (StyxWoW.Me.Shapeshift == ShapeshiftForm.EpicFlightForm ||
                 StyxWoW.Me.Shapeshift == ShapeshiftForm.FlightForm))
                return;
            if ((GetAsyncKeyState(Keys.LButton) != 0 && GetAsyncKeyState(Keys.RButton) != 0) ||
                GetAsyncKeyState(Keys.W) != 0 ||
                GetAsyncKeyState(Keys.S) != 0 ||
                GetAsyncKeyState(Keys.D) != 0 ||
                GetAsyncKeyState(Keys.A) != 0)
            {
                Logging.Write(LogLevel.Diagnostic, "Walking manually, turn off movement!");
                EnableMovement = false;
            }
            else
                EnableMovement = true;
            if (EnableMovement)
            {
                if (SuperbadSettings.Instance.UseTargeting)
                    EnsureTarget();

                //Get Away from frozen Target!
                if (StyxWoW.Me.Specialization == WoWSpec.MageFrost)
                {
                    var runaway = Unit.NearbyUnfriendlyUnits.Where(
                        u => (u.CachedHasAura("Frost Nova") || u.CachedHasAura("Freeze")) &&
                             u.Distance < Unit.MeleeRange).
                                       OrderBy(u => u.DistanceSqr).FirstOrDefault();
                    if (runaway != null)
                    {
                        if (blink())
                            return;
                        var moveTo =
                            WoWMathHelper.CalculatePointBehind(
                                (runaway).Location,
                                (runaway).Rotation,
                                -(Unit.MeleeRange + 5f));
                        if (Navigator.CanNavigateFully(StyxWoW.Me.Location, moveTo))
                        {
                            Logging.Write("Getting away from frozen target");
                            Navigator.MoveTo(moveTo);
                            return;
                        }
                    }
                }
                //MoveToLos
                if (SuperbadSettings.Instance.UseMovement)
                {
                    if (StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget != StyxWoW.Me &&
                        !StyxWoW.Me.CurrentTarget.InLineOfSight)
                        Navigator.MoveTo(StyxWoW.Me.CurrentTarget.Location);
                    //FaceTarget
                    if (StyxWoW.Me.CurrentTarget != null && !StyxWoW.Me.IsMoving && !StyxWoW.Me.CurrentTarget.IsMe &&
                        !StyxWoW.Me.IsSafelyFacing(StyxWoW.Me.CurrentTarget, 70f))
                        StyxWoW.Me.CurrentTarget.Face();
                    //MoveToMelee
                    if (StyxWoW.Me.Class == WoWClass.Mage)
                    {
                        if (StyxWoW.Me.CurrentTarget != StyxWoW.Me && !StyxWoW.Me.IsCasting &&
                            StyxWoW.Me.CurrentTarget != null)
                        {
                            if (StyxWoW.Me.Location.Distance(StyxWoW.Me.CurrentTarget.Location) < 39f)
                            {
                                if (StyxWoW.Me.IsMoving)
                                {
                                    Navigator.PlayerMover.MoveStop();
                                }
                            }
                            else
                            {
                                Navigator.MoveTo(StyxWoW.Me.CurrentTarget.Location);
                            }
                        }
                    }

                    if (StyxWoW.Me.Class == WoWClass.Druid)
                    {
                        if (!StyxWoW.Me.IsCasting)
                        {
                            var range = StyxWoW.Me.CurrentTarget != null && StyxWoW.Me.CurrentTarget.IsPlayer
                                            ? 2f
                                            : MeleeRange;
                            if (StyxWoW.Me.CurrentTarget != null &&
                                StyxWoW.Me.Location.Distance(StyxWoW.Me.CurrentTarget.Location) < range)
                            {
                                if (StyxWoW.Me.IsMoving)
                                {
                                    Navigator.PlayerMover.MoveStop();
                                }
                            }
                            else
                            {
                                if (StyxWoW.Me.CurrentTarget != null)
                                    Navigator.MoveTo(StyxWoW.Me.CurrentTarget.Location);
                            }
                        }
                        //MoveBehind
                        if (StyxWoW.Me.CurrentTarget != null &&
                            (StyxWoW.Me.IsInInstance && !StyxWoW.Me.CurrentTarget.IsTargetingMeOrPet))
                        {
                            if (StyxWoW.Me.CurrentTarget != null && (!StyxWoW.Me.IsCasting &&
                                                                     StyxWoW.Me.Role != WoWPartyMember.GroupRole.Tank &&
                                                                     !StyxWoW.Me.CurrentTarget.MeIsBehind &&
                                                                     StyxWoW.Me.CurrentTarget.IsAlive
                                                                    ))
                            {
                                Navigator.MoveTo(CalculatePointBehindTarget());
                            }
                        }
                    }
                }
            }
            if (StyxWoW.Me.Specialization == WoWSpec.MageFrost)
            {
                FrostRotation();
                return;
            }
            if (StyxWoW.Me.Specialization == WoWSpec.MageArcane)
            {
                ArcaneRotation();
                return;
            }
            if (StyxWoW.Me.CurrentTarget != null)
            {
                if (StyxWoW.Me.IsCasting || StyxWoW.Me.IsChanneling)
                    return;
                if (mighty_bash())
                    return;
                if (WoWSpec.DruidFeral == StyxWoW.Me.Specialization)
                    FeralRotations();
                if (WoWSpec.DruidGuardian == StyxWoW.Me.Specialization)
                    GuardianRotations();
            }
        }


        public static float MeleeDistance(WoWUnit mob)
        {
            if (mob == null)
                return 0;

            if (mob.IsPlayer)
                return 3.5f;

            return Math.Max(5f, StyxWoW.Me.CombatReach + 1.3333334f + mob.CombatReach);
        }

        public static void EnsureTarget()
        {
            if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear && StyxWoW.Me.IsInInstance &&
                TankManager.TargetingTimer.IsFinished && StyxWoW.Me.Combat && TankManager.Instance.FirstUnit != null &&
                (StyxWoW.Me.CurrentTarget == null || StyxWoW.Me.CurrentTarget != TankManager.Instance.FirstUnit))
            {
                // Logging.Write("Targeting first unit of TankTargeting");
                TankManager.Instance.FirstUnit.Target();
                TankManager.TargetingTimer.Reset();
            }

            var ctx = GatherTarget();
            if (ctx != null)
            {
                // Logging.Write("Current target is not the best target. Switching to " + ctx + "!");
                ((WoWUnit) ctx).Target();
            }

            if (StyxWoW.Me.CurrentTarget == null || StyxWoW.Me.CurrentTarget.IsDead)
            {
                ctx = GatherTarget2();
                if (ctx != null)
                {
                    // Logging.Write("Currect target is invalid. Switching to " + ctx + "!");
                    ((WoWUnit) ctx).Target();
                }
            }
        }

        private static WoWObject GatherTarget2()
        {
            // If we have a RaF leader, then use its target.
            var rafLeader = RaFHelper.Leader;
            if (rafLeader != null && rafLeader.IsValid && !rafLeader.IsMe && rafLeader.Combat &&
                rafLeader.CurrentTarget != null && rafLeader.CurrentTarget.IsAlive &&
                !Blacklist.Contains(rafLeader.CurrentTarget))
            {
                return rafLeader;
            }

            // Check bot poi.
            if (BotPoi.Current.Type == PoiType.Kill)
            {
                var unit = BotPoi.Current.AsObject as WoWUnit;

                if (unit != null && unit.IsAlive && !unit.IsMe && !Blacklist.Contains(unit))
                {
                    return unit;
                }
            }

            // Does the target list have anything in it? And is the unit in combat?
            // Make sure we only check target combat, if we're NOT in a BG. (Inside BGs, all targets are valid!!)
            var firstUnit = Targeting.Instance.FirstUnit;
            if (firstUnit != null && firstUnit.IsAlive && !firstUnit.IsMe && firstUnit.Combat &&
                !Blacklist.Contains(firstUnit))
            {
                return firstUnit;
            }

            // Cache this query, since we'll be using it for 2 checks. No need to re-query it.
            var agroMob =
                ObjectManager.GetObjectsOfType<WoWUnit>(false, false).
                              Where(p => !Blacklist.Contains(p) && p.IsHostile && !p.IsOnTransport && !p.IsDead &&
                                         !p.Mounted && p.DistanceSqr <= 70*70 && p.Combat).
                              OrderBy(u => u.DistanceSqr).
                              FirstOrDefault();

            if (agroMob != null)
            {
                // Return the closest one to us
                return agroMob;
            }

            // And there's nothing left, so just return null, kthx.
            return null;
        }

        private static WoWObject GatherTarget()
        {
            // No target switching for tanks. They check for their own stuff above.
            if (StyxWoW.Me.Shapeshift == ShapeshiftForm.Bear && StyxWoW.Me.IsInInstance)
                return null;
            // Go below if current target is null or dead. We have other checks to deal with that
            if (StyxWoW.Me.CurrentTarget == null || StyxWoW.Me.CurrentTarget.IsDead)
                return null;
            // If the current target is in combat or has aggro towards us, it should be a valid target.
            if (StyxWoW.Me.CurrentTarget != null && (StyxWoW.Me.CurrentTarget.Combat || StyxWoW.Me.CurrentTarget.Aggro))
                return null;
            if (BotPoi.Current.Type == PoiType.Kill)
            {
                var obj = BotPoi.Current.AsObject;

                if (obj != null)
                {
                    if (StyxWoW.Me.CurrentTarget != obj)
                        return obj;
                }
            }
            // Make sure we have the proper target from Targeting. 
            // The Botbase should give us the best target in targeting.
            var firstUnit = Targeting.Instance.FirstUnit;

            if (firstUnit != null)
            {
                if (StyxWoW.Me.CurrentTarget != firstUnit)
                    return firstUnit;
            }
            return null;
        }

        private static WoWPoint CalculatePointBehindTarget()
        {
            return
                StyxWoW.Me.CurrentTarget.Location.RayCast(
                    StyxWoW.Me.CurrentTarget.Rotation + WoWMathHelper.DegreesToRadians(150), MeleeRange - 2f);
        }
    }
}