﻿#region

using System.IO;
using Styx;
using Styx.Common;
using Styx.Helpers;

#endregion

namespace Superbad
{
    public class SuperbadSettings : Settings
    {
        public enum Keypress
        {
            None,
            LSHIFT,
            RSHIFT,
            LCTRL,
            RCTRL,
            LALT,
            RALT
        };

        public static readonly SuperbadSettings Instance = new SuperbadSettings();

        public SuperbadSettings()
            : base(
                Path.Combine(Utilities.AssemblyDirectory,
                             string.Format(@"Routines/Config/Superbad-Settings-{0}.xml", StyxWoW.Me.Name))
                )
        {
        }


        /*Feral Settings*/

        [Setting,
         DefaultValue(false)]
        public bool UseRebirth { get; set; }

        [Setting,
         DefaultValue(0)]
        public int RebirthMode { get; set; }

        [Setting, DefaultValue(Keypress.None)]
        public Keypress PauseKey { get; set; }

        [Setting,
         DefaultValue(2)]
        public int Form { get; set; }

        [Setting,
         DefaultValue(false)]
        public bool WrathSpam { get; set; }

        [Setting,
         DefaultValue(0)]
        public int HealingTouchCombat { get; set; }

        [Setting,
         DefaultValue(0)]
        public int RejuvenationCombat { get; set; }

        [Setting,
         DefaultValue(3)]
        public int AddsBearSwitch { get; set; }

        [Setting,
         DefaultValue(5)]
        public int CatAOE { get; set; }

        [Setting,
         DefaultValue(3)]
        public int BearAOE { get; set; }

        [Setting,
         DefaultValue(35)]
        public int HealthBearSwitch { get; set; }

        [Setting,
         DefaultValue(35)]
        public int RestHealth { get; set; }

        [Setting,
         DefaultValue(35)]
        public int RestMana { get; set; }

        [Setting,
         DefaultValue(35)]
        public int HealthStone { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool Wolves { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool TurnOffDungeonBear { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseDash { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseStampedingRoar { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseNaturesSwiftness { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseMovement { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseSavageDefense { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseFrenziedRegen { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseSpeedBoost { get; set; }

        [Setting,
         DefaultValue(false)]
        public bool StayInStealth { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool PullStealth { get; set; }

        [Setting,
         DefaultValue(0)]
        public int StealthOpener { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool useHotW { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseTargeting { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseFFF { get; set; }

        [Setting,
         DefaultValue(false)]
        public bool PrintMsg { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool Mdw { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool HealOthers { get; set; }


        [Setting,
         DefaultValue(false)]
        public bool RakeCycle { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool MightyBash { get; set; }

        [Setting,
         DefaultValue(false)]
        public bool Rooted { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool RootedSpeed { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool WaitSickness { get; set; }

        [Setting,
         DefaultValue(false)]
        public bool Mdwgroup { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseInterrupts { get; set; }

        [Setting,
         DefaultValue(false)]
        public bool UsePotion { get; set; }

        [Setting,
         DefaultValue(false)]
        public bool UseBlink { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseStealth { get; set; }

        [Setting,
         DefaultValue(false)]
        public bool SavageFarm { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseBerserk { get; set; }

        [Setting,
         DefaultValue(70)]
        public int Barkskin { get; set; }

        [Setting,
         DefaultValue(80)]
        public int Frenzied { get; set; }

        [Setting,
         DefaultValue(25)]
        public int OoCHealingTouch { get; set; }

        [Setting,
         DefaultValue(70)]
        public int OoCReju { get; set; }

        [Setting,
         DefaultValue(20)]
        public int MightofUrsoc { get; set; }

        [Setting,
         DefaultValue(0)]
        public int Trinket1Usage { get; set; }

        [Setting,
         DefaultValue(30)]
        public int Trinket1Percent { get; set; }

        [Setting,
         DefaultValue(0)]
        public int Trinket2Usage { get; set; }

        [Setting,
         DefaultValue(30)]
        public int Trinket2Percent { get; set; }


        [Setting,
         DefaultValue(80)]
        public int Natures { get; set; }

        [Setting,
         DefaultValue(70)]
        public int LifeSpirit { get; set; }

        [Setting,
         DefaultValue(70)]
        public int Renewal { get; set; }

        [Setting,
         DefaultValue(95)]
        public int CenarionWard { get; set; }

        [Setting,
         DefaultValue(80)]
        public int Predatory { get; set; }

        [Setting,
         DefaultValue(25)]
        public int Survival { get; set; }

        [Setting,
         DefaultValue(true)]
        public bool UseTaunt { get; set; }
    }
}