﻿#region

using System;
using System.Linq;
using McLovin;
using Styx;
using Styx.CommonBot;
using Styx.WoWInternals;

#endregion

namespace Superbad
{
    internal partial class cooldown
    {
        public static double dash
        {
            get { return Spell.GetSpellCooldown("Dash").TotalSeconds; }
        }

        public static double darkflight
        {
            get { return Spell.GetSpellCooldown("Darkflight").TotalSeconds; }
        }

        public static double wild_charge
        {
            get { return Spell.GetSpellCooldown("Wild Charge").TotalSeconds; }
        }

        public static double prowl
        {
            get { return Spell.GetSpellCooldown("Prowl").TotalSeconds; }
        }

        #region Nested type: alter_time_activate

        public class alter_time_activate
        {
            public static double remains
            {
                get
                {
                    return SpellManager.HasSpell("Alter Time")
                               ? SpellManager.Spells["Alter Time"].CooldownTimeLeft.TotalSeconds
                               : 99;
                }
            }
        }

        #endregion

        #region Nested type: honor_among_thieves

        public class honor_among_thieves
        {
            public static double remains
            {
                get { throw new NotImplementedException(); }
            }
        }

        #endregion

        #region Nested type: icy_veins

        public class icy_veins
        {
            public static double remains
            {
                get
                {
                    if (!TalentManager.HasGlyph("Icy Veins"))
                    {
                        return SpellManager.HasSpell("Icy Veins")
                                   ? SpellManager.Spells["Icy Veins"].CooldownTimeLeft.TotalSeconds
                                   : 99;
                    }
                    return SpellManager.HasSpell("Icy Veins")
                               ? WoWSpell.FromId(131078).CooldownTimeLeft.TotalSeconds
                               : 99;
                }
            }
        }

        #endregion

        #region Nested type: shadow_dance

        public class shadow_dance
        {
            public static double remains
            {
                get
                {
                    return SpellManager.HasSpell("Shadow Dance")
                               ? SpellManager.Spells["Shadow Dance"].CooldownTimeLeft.TotalSeconds
                               : 99;
                }
            }
        }

        #endregion

        #region Nested type: vanish

        public class vanish
        {
            public static double remains
            {
                get
                {
                    return SpellManager.HasSpell("Vanish")
                               ? SpellManager.Spells["Vanish"].CooldownTimeLeft.TotalSeconds
                               : 0;
                }
            }
        }

        #endregion

        public class arcane_power
        {
            public static double remains
            {
                get { return Spell.GetSpellCooldown("Arcane Power").TotalSeconds; }
            }
        }

        public class mana_gem
        {
            public static double remains
            {
                get
                {
                    var firstOrDefault = StyxWoW.Me.BagItems.FirstOrDefault(i => i.Entry == 36799 || i.Entry == 81901);
                    if (firstOrDefault != null)
                        return firstOrDefault.CooldownTimeLeft.TotalSeconds;
                    return 11;
                }
            }
        }
    }
}